<template>
    <div id="postsrec">

        <div class="row justify-content-center">
            <div v-bind:class="{ succmsg: succmsg }">
                <div class="col-md-12 col-lg-12">
                    <div class="alert alert-success cusmsg">{{ actionmsg }}</div>
                </div>
            </div>
            <div class="col-md-12">
                <!-- Button trigger modal -->

                <!-- Modal -->

                <div class="modal fade" id="exampleModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true" v-bind:class="{ showmodal:showmodal }">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <form method = "post" name="addpostagem" id="addpostagem" action="#" @submit.prevent="updatePostagem">
                                    <div class="form-group">
                                        <label for="titulo">Titulo</label>
                                        <input type="text" name="titulo" id="titulo" class="form-control" placeholder="Titulo" v-model="postagem.titulo" />
                                    </div>
                                    <div class="form-group">
                                        <label for="postagem_content">Postagem</label>
                                        <textarea name="postagem_content" id="postagem_content" class="form-control" placeholder="Postagem" v-model="postagem.postagem_content"></textarea>
                                    </div>
                                    <div class="form-group">
                                        <label for="autor">Autor</label>
                                        <select class="form-control" name="autor" id="autor" v-model="postagem.autor">
                                            <option value="Autor_01">Autor_01</option>
                                            <option value="Autor_02">Autor_02</option>
                                            <option value="Autor_03">Autor_03</option>
                                        </select>
                                    </div>
                                    <div class="form-group text-right">
                                        <button class="btn btn-success">Atualizar</button>
                                    </div>
                                </form>
                            </div>

                        </div>
                    </div>
                </div>
                <div class="modal fade" id="exampleModal2" tabindex="-1" role="dialog" aria-labelledby="exampleModal2Label" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <div class="form-group">
                                    <p>Deseja excluir este registro? </p>
                                </div>
                                <div class="form-group text-center">
                                    <button class="btn btn-success" v-on:click="hideModal()">Cancel</button>
                                </div>
                                <div class="form-group text-center">
                                    <button class="btn btn-success" v-on:click="deletePostagem()">Ok</button>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>
                <div class="card">
                    <div class="card-header">Postagens</div>
                    <div class="card-body">
                        <table class="table table-striped" v-bind:pagenumber = "pagenumber">
                            <thead>
                                <tr>
                                    <th scope="col">Titulo</th>
                                    <th scope="col">Postagem</th>
                                    <th scope="col">Autor</th>
                                    <th scope="col" colspan="2">Opções</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="postagem in laravelData.data" :key="postagem.id">
                                    <th scope="row">{{ postagem.titulo }}</th>
                                    <td>{{ postagem.postagem_content.slice(0,50) + "....." }}</td>
                                    <td>{{ postagem.autor }}</td>
                                    <td><a href="#" v-on:click="editPostagem(postagem.id)" data-target="#exampleModal"  data-toggle="modal" v-bind:title="postagem.title">Edit</a></td>
                                    <td><a href="#" data-target="#exampleModal2" v-on:click="deleteId(postagem.id)"  data-toggle="modal" v-bind:id="id"  >Delete</a></td>
                                </tr>
                            </tbody>
                        </table>
                        <pagination :data="laravelData" :limit="2" @pagination-change-page="postagemLists">
                            <span slot="prev-nav">&lt; Previous</span>
                            <span slot="next-nav">Next &gt;</span>
                        </pagination>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>

    export default {

        data() {
            return {
                postagem: {
                    "titulo": '',
                    "postagem_content": '',
                    "autor": ''
                },
                laravelData: {},
                id: '',
                succmsg:  true,
                showmodal: false,
                pagenumber: 1,
                actionmsg: '',
            }
        },
        methods: {
            postagemLists(page) {
                if (typeof page === 'undefined') {
                    page = 1;
                }
                this.$http.get('http://127.0.0.1:8000/api/postagens?page='+ page).then((response) => {
                    this.postages = response.data.data;
                    this.laravelData = response.data;
                    this.pagenumber = page;
                });
            },
            editPostagem(postid) {
                this.$http.get('http://127.0.0.1:8000/api/postagens/'+ postid).
                then((data) => {
                    this.postagem.titulo = data.data.data.titulo;
                    this.postagem.postagem_content = data.data.data.postagem_content;
                    this.postagem.autor = data.data.data.autor;
                    this.id = postid;
                });
            },
            updatePostagem() {
                this.$http.put('http://127.0.0.1:8000/api/postagens/'+this.id,{
                    'titulo': this.postagem.titulo,
                    'postagem_content': this.postagem.postagem_content,
                    'autor': this.postagem.autor
                }).
                then((data) => {
                    this.succmsg = false;
                    console.log(data);
                    this.postagem.titulo = '';
                    this.postagem.postagem_content = '';
                    this.postagem.autor = '';
                    var self = this;
                    setTimeout(function(){
                        self.succmsg = true;
                    },3000);
                    this.actionmsg = "Dados atualizados com sucesso!";
                    $('#exampleModal').modal('hide');
                    this.postagemLists(this.pagenumber);

                });
            },
            deleteId(postid) {
                this.id = postid;
            },
            deletePostagem() {
                this.$http.delete('http://127.0.0.1:8000/api/postagens/'+this.id).
                then((data) => {
                    this.succmsg = false;;
                    var self = this;
                    setTimeout(function(){
                        self.succmsg = true;
                    },3000);

                    this.actionmsg = "Postagem deletada com sucesso!";
                    this.postagemLists(this.pagenumber);
                    $('#exampleModal2').modal('hide');

                });
            },
            hideModal() {
                $('#exampleModal2').modal('hide');
            }

        },
        mounted() {
            this.postagemLists();
        }
    }
</script>
<style scoped>
    .succmsg {
        display: none;
    }
    .showmodal {
        display: none !important;
        opacity: 0;
    }
</style>
